<template lang="pug">
  .text-properties(:class="{ 'new-list': isNewList, 'current-list': !isNewList }")
    .title {{ isNewList ? 'Add text' : 'Change font' }}
    .scroll-container(v-app-scroll)
      .list
        .item(
          v-for="(font, index) in loadedFonts"
          :class="{ active: !isNewList && font.title === currentFontFamily }"
          @click="handleClick(font)"
        )
          .text(:style="getFontStyle(font)") The quick brown fox jumps over the lazy dog
          .font-name {{ font.title }}

</template>

<script>
import { mapState } from 'vuex'
import storeService from '../../services/store'
import itemsService from '../../services/items/common'
import textService from '../../services/items/text'
import AddItemCommand from '../../history/commands/addItem'
import TextChangeFontCommand from '../../history/commands/text/changeFont'

export default {
  name: 'TextProperties',
  data () {
    return {
      fontFamily: undefined,
      currentFontFamily: null,
      TYPE_TEXT: itemsService.TYPE_TEXT,
      text: null
    }
  },
  computed: {
    ...mapState({
      activeItem: state => state.editor.activeItem,
      loadedFonts: state => state.editor.loadedFonts
    }),
    isNewList: function () {
      return !this.activeItem || this.activeItem.type !== itemsService.TYPE_TEXT
    }
  },
  watch: {
    fontFamily () {
      this.textFontFamily(this.fontFamily)
    },
    activeItem () {
      this.setText()
    }
  },
  mounted () {
    this.setText()
  },
  methods: {
    getFontStyle (font) {
      const fontWeight = font.weight === 'bold' ? '700' : 'normal'
      return `font-family:'${font.title}';font-weight:${fontWeight}`
    },
    addText (fontTitle) {
      storeService.get('commandManager').execute(new AddItemCommand({ type: itemsService.TYPE_TEXT, fontFamily: fontTitle }, {}, true))
    },
    changeFontFamily (fontTitle) {
      this.currentFontFamily = fontTitle
      storeService.get('commandManager').execute(new TextChangeFontCommand(storeService.get('activeItem'), fontTitle))
    },
    handleClick (font) {
      this.$emit('selected')
      return this.isNewList ? this.addText(font.title) : this.changeFontFamily(font.title)
    },
    setText () {
      const activeItem = storeService.get('activeItem')
      const isTextItem = activeItem && activeItem.getAttrs().objectData.type === itemsService.TYPE_TEXT
      this.text = isTextItem ? activeItem.text() : textService.getDefaultText()
      this.currentFontFamily = isTextItem ? activeItem.fontFamily() : null
    }
  }
}
</script>

<style lang="scss" scoped>
@import '../../assets/css/variables';

.text-properties {
  height: calc(100% - 36px);
  color: #000;
  padding: 0 8px 8px 4px;

  .current-list {
    height: 100%;
  }

  .description {
    padding: 15px 10px;
    text-align: center;
    text-transform: uppercase;
    font-weight: bold;
  }

  .title {
    height: 56px;
    color: #fff;
    display: flex;
    align-items: center;
    font-size: 24px;
    text-transform: uppercase;
    font-weight: bold;
  }

  .scroll-container {
    height: calc(100% - 68px);
  }

  .list {
    padding: 0;

    .item {
      padding: 8px 16px 16px 16px;
      background-color: rgba(255, 255, 255, 0.1);
      border-radius: 8px;
      margin: 0 0 8px 0;
      cursor: pointer;

      .text {
        font-size: 24px;
        color: #fff;
        white-space: nowrap;
        overflow: hidden;
        text-overflow: ellipsis;
        padding-bottom: 5px;
      }

      .font-name {
        font-size: 14px;
        color: rgba(255, 255, 255, 0.5);
      }

      &.active, &:hover {
        background-color: rgba(255, 255, 255, 0.2);
      }
    }
  }
}
</style>
